/**
 * easyWSDL - easyWSDL toolbox Platform.
 * Copyright (c) 2008,  eBM Websourcing
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.ow2.easywsdl.wsdl.decorator;

import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.schema.api.Documentation;
import org.ow2.easywsdl.schema.api.XmlException;
import org.ow2.easywsdl.schema.api.abstractElmt.AbstractSchemaElementImpl;
import org.ow2.easywsdl.wsdl.api.WSDLElement;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfBinding;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfBindingOperation;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfInterfaceType;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfBinding.BindingConstants;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfBinding.StyleConstant;
import org.w3c.dom.Element;


/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
@SuppressWarnings("unchecked")
public class DecoratorBindingImpl<I extends AbsItfInterfaceType, BO extends AbsItfBindingOperation>  extends AbstractWSDLElementImpl implements Decorator {

    /**
	 *
	 */
    private static final long serialVersionUID = 1L;

    protected AbsItfBinding<I, BO> binding;

    public DecoratorBindingImpl(final AbsItfBinding<I, BO> binding) throws WSDLException {
        this.binding = binding;
    }

    public void addBindingOperation(final BO arg0) {
        this.binding.addBindingOperation(arg0);
    }

    public BO getBindingOperation(final String arg0) {
        return this.binding.getBindingOperation(arg0);
    }

    public List<BO> getBindingOperations() {
        return this.binding.getBindingOperations();
    }

    public String getHttpContentEncodingDefault() {
        return this.binding.getHttpContentEncodingDefault();
    }

    public String getHttpDefaultMethod() {
        return this.binding.getHttpDefaultMethod();
    }

    public String getHttpQueryParameterSeparatorDefault() {
        return this.binding.getHttpQueryParameterSeparatorDefault();
    }

    public I getInterface() {
        return this.binding.getInterface();
    }

    public QName getQName() {
        return this.binding.getQName();
    }

    public StyleConstant getStyle() {
        return this.binding.getStyle();
    }

    public String getTransportProtocol() {
        return this.binding.getTransportProtocol();
    }

    public BindingConstants getTypeOfBinding() {
        return this.binding.getTypeOfBinding();
    }

    public String getVersion() {
        return this.binding.getVersion();
    }

    public boolean isHttpCookies() {
        return this.binding.isHttpCookies();
    }

    public BO removeBindingOperation(final String arg0) {
        return this.binding.removeBindingOperation(arg0);
    }

    public void setInterface(final I arg0) {
        this.binding.setInterface(arg0);
    }

    public void setQName(final QName arg0) {
        this.binding.setQName(arg0);
    }

    public void setTransportProtocol(String transportProtocol) throws WSDLException {
        this.binding.setTransportProtocol(null);
    }

    public Documentation createDocumentation() {
        return this.binding.createDocumentation();
    }

    public Documentation getDocumentation() {
        return this.binding.getDocumentation();
    }

    public Map<QName, String> getOtherAttributes() throws XmlException {
        return this.binding.getOtherAttributes();
    }

    public List<Element> getOtherElements() throws XmlException {
        return this.binding.getOtherElements();
    }

    public void setDocumentation(final Documentation arg0) {
        this.binding.setDocumentation(arg0);
    }

	public BO createBindingOperation() {
		return this.binding.createBindingOperation();
	}

    @Override
	public Object getModel() {
		return ((AbstractWSDLElementImpl)this.binding).getModel();
	}

    @Override
	public AbstractSchemaElementImpl getParent() {
		return ((AbstractWSDLElementImpl)this.binding).getParent();
	}

	public WSDLElement getDecorator() {
		return this.binding;
	}
}
